$INTERFACE U0SSU1                                             97/12/01
$REM LU
  $N='NF'
  $ADD(REAL,'\$AFO($NA)')
  $ADD(INTEGER,'\IMD\IMS\LDS\METS')
  $JARA='S'
  $D='D'
  $GN=G
  $AGS=AG
  $AGH='AGH'
  $IF(CONSTR='S')
    $CONSTR='C'
    $ADD(REAL,'\UXUDOT')
  $ELSE
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $LU=0
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $IF(NA=NF)
    $HELP
      MATRIX DECOMPOSITION:
        A - RECTANGULAR MATRIX
        E - GENERAL MATRIX FOR NONLINEAR EQUATIONS
    $CHECK(DECOMP,'E','A\E',2,NO)
  $ELSE
    $DECOMP='A'
  $ENDIF
  $IF(TYPE='L')
    $IF(DECOMP='A')
      $HELP
         METHOD
           1 - EXACT SOLUTION BY SPARSE QR FACTORIZATION
           2 - EXACT SOLUTION BY SPARSE BUNCH-PARLETT FACTORIZATION
               OF AUGMENTED SYSTEM
           3 - INEXACT SOLUTION BY CGLS METHOD
           4 - INEXACT SOLUTION BY LSQR METHOD
      $CHECK(NUMBER,3,'1\2\3\4',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - EXACT SOLUTION BY SPARSE LU FACTORIZATION
           3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
           4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
           5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\3\4\5',2,NO)
      $IF(NUMBER>2)
        $HELP
          PRECONDITIONING TECHNIQUE
            ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
            ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
            ABS(MOS2)=2 - SSOR PRECONDITIONING
               MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
               MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                          BY PRECONDITIONED ITERATIVE PROCESS
        $CHECK(MOS2,1,'-2\-1\0\1\2',1)
        $IF(MOS2<>0) $LU=1
      $ENDIF
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(DECOMP='A')
      $HELP
         METHOD
           1 - DOG-LEG STRATEGY WITH SPARSE QR FACTORIZATION
           2 - EXACT SOLUTION BY SPARSE BUNCH-PARLETT FACTORIZATION
               OF AUGMENTED SYSTEM
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY LSQR METHOD
           7 - OPTIMUM LOCALLY CONSTRAINED STEP BY QR
               FACTORIZATION
      $CHECK(NUMBER,3,'1\2\3\4\7',2,NO)
    $ELSE
      $HELP
         METHOD
           1 - DOG-LEG STRATEGY WITH SPARSE LU FACTORIZATION
           2 - MULTIPLE DOG-LEG STRATEGY WITH SPARSE LU
               FACTORIZATION
           3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
           4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
           5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\2\3\4\5',2,NO)
      $IF(NUMBER>2)
        $HELP
          PRECONDITIONING TECHNIQUE
            ABS(MOS2)=0 - PRECONDITIONING IS SUPPRESSED
            ABS(MOS2)=1 - INCOMPLETE LU PRECONDITIONING
            ABS(MOS2)=2 - SSOR PRECONDITIONING
               MOS2 < 0 - PRECONDITIONED ITERATIVE PROCESS
               MOS2 > 0 - PRELIMINARY INEXACT SOLUTION FOLLOWED
                          BY PRECONDITIONED ITERATIVE PROCESS
        $CHECK(MOS2,1,'-2\-1\0\1\2',1)
        $IF(MOS2<>0) $LU=1
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(TYPE='L')
    $KDS=0
    $HELP
      LINE SEARCH INTERPOLATION
        1 - BISECTION
        2 - TWO POINT QUADRATIC INTERPOLATION
        3 - THREE POINT QUADRATIC INTERPOLATION
        4 - THREE POINT CUBIC INTERPOLATION
        5 - SPECIAL BIQUADRATIC INTERPOLATION
    $CHECK(MES,1,'1\2\3\4\5',3)
    $STEP=1
    $IF(MES=5) $STEP=4
    $DEFAULT=-2
    $IF(NA=NF) $DEFAULT=1
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
                0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED
    $CHECK(INITS,DEFAULT,'-4\-3\-2\-1\1\2\3\4',4)
    $HELP
      CONTROLLING OF THE INITIAL STEPSIZE:
        0-NO CONTROLLING OF THE INITIAL STEPSIZE
        1-CONTROLLING BASED ON THE FUNCTION DECREASE
        2-CONTROLLING BASED ON THE DIRECTION VECTOR
        3-CONTROLLING BASED ON THE NUMBER OF FUNCTIONS
    $CHECK(ISTEP,0,'0\1\2\3',4)
    $HELP
      TOLERANCE FOR DESCENT DIRECTION
    $CHECK(EPS0,ETA0,REAL,4)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
  $ELSE
    $HELP
      MAXIMUM NUMBER OF ZERO STEPS IN ONE ITERATION
    $CHECK(MRED,5,INT,4)
    $ISTEP=0
    $HELP
      LINE SEARCH
        1 - FOR MINIMIZATION
        2 - FOR NONLINEAR EQUATIONS
    $CHECK(STEP,1,'1\2',4,NO)
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
  $ENDIF
  $HELP
    COMPUTATION OF DERIVATIVES
      1 - DERIVATIVES OF APPROXIMATING FUNCTIONS ARE
          COMPUTED
      2 - COLEMAN-MORE GRAPH COLORING ALGORITHM IS USED
  $CHECK(NUMDER,1,'1\2',4,NO)
  $DEC=DECOMP
  $IF(NUMBER>2) $DEC='A'
  $IF(NUMDER=1)
    $HELP
      TYPE OF UPDATE
        B - THE SPARSE BROYDEN UPDATE
        A - THE SPARSE ADJOINT BROYDEN UPDATE
        S - ROW SCALING UPDATE
        T - TENSOR METHOD
        N - NEWTON METHOD
    $CHECK(UPDATE,'N','B\A\S\T\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
  $ELSE
    $HELP
      TYPE OF UPDATE
        B - THE SPARSE BROYDEN UPDATE
        A - THE SPARSE ADJOINT BROYDEN UPDATE
        S - ROW SCALING UPDATE
        C - CYCLIC COLUMN CORRECTION
        T - TENSOR METHOD
        N - NEWTON METHOD
    $CHECK(UPDATE,'N','B\A\S\C\T\NO\N',3,NO)
    $IF(UPDATE='N') $UPDATE='NO'
  $ENDIF
  $IF(TYPE='L')
    $IF(UPDATE='NO')
    $ELSEIF(UPDATE='T')
    $ELSE
      $HELP
        MAXIMUM NUMBER OF ZERO STEPS IN ONE ITERATION
      $CHECK(MRED,10,INT,4)
    $ENDIF
  $ELSE
    $HELP
      STRATEGY FOR RESTART
        0 - RESTART AFTER UNSUCCESSFUL STEP
        1 - RESTART AFTER LARGE STEP
        2 - RESTART AFTER LARGE BOUNDARY STEP
    $CHECK(MES3,1,'0\1\2')
  $ENDIF
  $IPOM2=0
  $UPD=UPDATE
  $IF(UPD='S')
    $IF(NUMBER>2) $UPD='M'
  $ENDIF
  $IF(UPD='B')
    $IPOM2=1
    $HELP
      UPDATE OF THE JACOBIAN MATRIX:
        1 - THE BROYDEN-SCHUBERT UPDATE
        2 - THE BOGGLE-PERKINS UPDATE
        3 - THE COLUMN UPDATE
    $CHECK(MET,1,'1\2\3',3)
  $ELSEIF(UPD='A')
    $GG='GG'
    $ADD(REAL,'\$GG($NF)')
    $ADD(INTEGER,'\KH')
    $IPOM2=1
  $ELSEIF(UPD='S')
    $IF(DECOMP='A')
      $IF(NUMBER=1) $MET=0
      $IF(NUMBER=2) $MET=0
    $ENDIF
    $HELP
      UPDATE OF THE LU DECOMPOSITION:
        0 - NO UPDATE
        1 - THE MARTINEZ ROW SCALING UPDATE
    $CHECK(MET,0,'0\1',3)
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES1,0,INT,4)
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES2,5,INT,4)
    $IPOM2=1
    $IF(MET=0) $UPD='X'
  $ELSEIF(UPD='C')
    $HELP
      ADDITIONAL UPDATE OF THE JACOBIAN MATRIX:
        0 - ADDITIONAL UPDATE IS SUPPRESSED
        1 - ADDITIONAL BROYDEN-SCHUBERT UPDATE
        2 - ADDITIONAL BOGGLE-PERKINS UPDATE
        3 - ADDITIONAL COLUMN UPDATE
    $CHECK(MET,1,'0\1\2\3',3)
    $IF(MET>0) $IPOM2=1
  $ELSEIF(UPD='M')
    $HELP
      UPDATE OF THE OLD JACOBIAN MATRIX:
        0 - NO UPDATE
        1 - ROW SCALING UPDATE
    $CHECK(MET,0,'0\1',3)
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES1,0,INT,4)
    $HELP
      RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
      IRES1*N+IRES2 ITERATIONS.
    $CHECK(IRES2,5,INT,4)
    $IPOM2=1
  $ELSEIF(UPD='T')
    $NUMBER=2
  $ENDIF
  $IF(DECOMP='A')
    $HELP
      CHOICE OF THE SCALING MATRIX:
        0 - UNIT MATRIX (NO SCALING)
        1 - SQUARE OF THE MATRIX H DIAGONAL
    $CHECK(MOS1,0,'0\1',4)
    $DEFAULT='1.0$P-6'
    $HELP
      LOWER BOUND FOR GRADIENT
    $CHECK(TOLG,DEFAULT,REAL,3)
  $ENDIF
  $ISNF=0
  $ISNA=3
  $ADD(INIT)
    ISNA=3
  $ENDADD
  NDECF=0
  IPOM2=$IPOM2
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $MAL=NA
   MAL=NA
  $JOB=1
  $IF(NORMA>0) $SUBST('UANRL1')
  $IF(NORMF>0) $SUBST('UATRL1')
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR='C') $SUBST('UYFPC1')
  $IF(LU=1) $SUBST('UYGISJ')
  $IF(NUMDER=2) $SUBST('UYCMSA')
  $IF(DECOMP='A')
    $IF(NUMBER=1) $SUBST('UYSFSL')
    $IF(NUMBER=2) $SUBST('UYSFIS')
    $IF(NUMBER=7) $SUBST('UYSFSG')
  $ENDIF
*
*     --------------------------
*     SPARSE QUASI-NEWTON METHOD
*     TEMPLATE : U0SSU1
*     --------------------------
*
  $LMD=$10
  $LMS=$35
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',0)
  CALL UYPRO3(1)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  METS=MET
$L=$10 ; $LABEL
  $IF(UPD='A')
    $GH=G
    $G=GG
    KH=KD
    KD=1
  $ENDIF
  $KD=0
  $SUBST('UZMODL')
  $IF(UPD='A')
    $G=GH
    KD=KH
    LD=KD
    IF (KD.GT.0) CALL UXVCOP(NF,$GG,$G)
  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  N=NF
$REM  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $95
  $IF(CONSTR='C') $SUBST('UYRM$(CONSTR)0')
  $IF(ISTEP=2)
    DMAX=R*SNORM
  $ENDIF
$L=$30 ; $LABEL
  $IF(UPDATE='NO')
  $ELSEIF(UPDATE='T')
  $ELSE
    MRED=$MRED
    IF (IREST.LE.0) MRED=5
  $ENDIF
  $IF(NUMDER=1)
    $SUBST('UUDRD1')
  $ELSE
    $SUBST('UUSRD2')
    GO TO $40
$L=$35 ; $LABEL
    ASSIGN $35 TO IMD
    $SUBST('UA0JS3')
    GOTO ($36,$10) ISB+1
$L=$36 ; $LABEL
    GO TO IMS
  $ENDIF
$L=$40 ; $LABEL
  $IF(UPD='S')
    IF(IDECA.EQ.0) CALL UXVSET(N,ONE,$D)
  $ENDIF
  IF(ITERM.NE.0) GOTO $95
  $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $AFS=AF
  $AFP='AFP'
  $IF(TYPE='L') $AFP=AFO
  $IF(UPD='S')
    CALL UXVMUL(N,$D,$AF,$AFP,1)
    $AF=AFP
  $ENDIF
  $MAT='G'
  $IF(UPD='T') $MAT='S'
  $DEC=DECOMP
  $DECOMG=DEC
  $NUM=NUMBER
  $IF(DECOMP='A')
    $IF(NUMBER=2) $NUM=1
  $ENDIF
  $IF(NUMBER=1) $DECOMG='A'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUM)
*     -----------------------
*
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUM)')
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $AF=AFS
  $IF(DECOMP<>'E')
    IF (KD.GT.0) THEN
    IF (GNORM.LE.TOLG) THEN
    TXFU='GRAD TOL'
    ITERM=4
    GOTO $95
    ENDIF
    ENDIF
    IF (KD.EQ.0) P=UXVDOT(NF,S,G)
    $ADD(REAL,'\UXVDOT')
  $ENDIF
  $IF(UPD='T')
    IF (NIT-LIT.GT.1) THEN
$REM    $SUBST('UD1T$(TYPE)1')
$REM    IF(ITERM.NE.0) GOTO $95
$REM    IF(IREST.NE.0) THEN
    IF (P.GE.ZERO) THEN
    CALL UXVCOP(NF,$SO,$SN)
    P=UXVDOT(NF,$SN,$GN)
    SNORM=UXVDOT(NF,$SN,$SN)
    ENDIF
    ENDIF
  $ENDIF
  $SUBST('UD1T$(TYPE)1')
  IF(ITERM.NE.0) GOTO $95
  IF(IREST.NE.0) GOTO $30
  LDS=LD
$L=$50 ; $LABEL
  $IF(ISTEP>0)
    CALL UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  $IF(CONSTR='C')
    IF (RMAX.EQ.ZERO) GO TO $75
  $ENDIF
  CALL UXVCOP(NA,$AF,$AFO)
$L=$60 ; $LABEL
  ASSIGN $60 TO IMD
  $SUBST('UZLINS')
  GOTO ($70,$65) ISB+1
$L=$65 ; $LABEL
  $IF(CONSTR='C')
    $IF(TYPE='G')
      CALL UXVDIR(NF,R,$S,$XO,$X)
    $ELSE
      CALL UXUDIR(NF,R,$S,$XO,$X,$IX,KBF)
    $ENDIF
    $SUBST('UCBS04')
  $ELSE
    CALL UXVDIR(NF,R,$S,$XO,$X)
  $ENDIF
  GOTO $10
$L=$70 ; $LABEL
  IF (ITERS.LE.0) THEN
  $SUBST('UYZER0')
  $IF(TYPE='L')
    CALL UXVCOP(NA,$AFO,$AF)
  $ELSE
    IF (MOT3.LE.0) CALL UXVCOP(NA,$AFO,$AF)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  LD=LDS
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  LD=LDS
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF (IPOM2.GT.0) THEN
  $SUBST('UUDRV1')
  ENDIF
  IF (IPOM1.EQ.1) KD=1
  IF(KD.GT.LD) THEN
  ASSIGN $80 TO IMD
  GO TO $10
  ENDIF
$L=$80 ; $LABEL
  KD=0
  TXFU = TUXX
  $IF(UPD<>'NO')
$REM    $IF(CONSTR='C') CALL UXVINB(NF,MA,$IX,$JAG)
  $ENDIF
  $IF(UPD='B')
    IF(IPOM1.EQ.2) THEN
      IDECA=0
      $SUBST('UYTR$(CONSTR)F')
      $SUBST('UUSBA1')
    ELSE
      $SUBST('UYTRUD')
    ENDIF
  $ELSEIF(UPD='A')
    IF(IPOM1.EQ.2) THEN
      IDECA=0
      $SUBST('UYTR$(CONSTR)F')
      $SUBST('UUSAA1')
    ELSE
      $SUBST('UYTRUD')
    ENDIF
  $ELSEIF(UPD='S')
    IF(IPOM1.EQ.2) THEN
      $SUBST('UYTR$(CONSTR)F')
      $SUBST('UUSSA1')
    ELSE
      $SUBST('UYTRUD')
    ENDIF
  $ELSEIF(UPD='X')
    IREST=0
    $SUBST('UYTRUD')
  $ELSEIF(UPD='C')
*
*     ----------------------
*     BEGIN OF THE LI UPDATE
*     ----------------------
*
    $SUBST('UUSCA1')
*
*     --------------------
*     END OF THE LI UPDATE
*     --------------------
*
    $IF(MET=0)
      $SUBST('UYTRUD')
    $ELSE
      $SUBST('UYTR$(CONSTR)F')
      $SUBST('UUSBA3')
    $ENDIF
  $ELSEIF(UPD='M')
    $IF(MET=0)
      IREST=0
      $SUBST('UYTRUD')
    $ELSE
      IF(IPOM1.EQ.2) THEN
        IDECA=0
        $SUBST('UYTR$(CONSTR)F')
        $SUBST('UUSBA4')
      ELSE
        $SUBST('UYTRUD')
      ENDIF
    $ENDIF
  $ELSEIF(UPD='T')
    IREST=1
    $SUBST('UYTR$(CONSTR)F')
  $ELSE
    IREST=1
    $SUBST('UYTRUD')
  $ENDIF
$L=$75 ; $LABEL
  MET=METS
  IF (IDIR.EQ.0) THEN
  IF (ITERH.NE.0) CALL UYRES1(TUXX)
  $IF(CONSTR='C') $SUBST('UYADC0')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$95 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(0)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U0SSU1'
  $ENDADD
  $EXIT
