$INTERFACE U1SDU1                                             97/12/01
$REM LU
  $N='N'
  $ADD(REAL,'\$AFO($NA)\UXVDOT')
  $ADD(INTEGER,'\IMD\METS')
  $JARA='D'
  $AGH='AGH'
  $HELP
    TYPE OF METHOD:
      L - LINE SEARCH
      G - GENERAL TRUST REGION
  $CHECK(TYPE,'G','L\G',2,NO)
  $IF(NA=NF)
    $HELP
      MATRIX DECOMPOSITION:
        A - RECTANGULAR MATRIX
        Q - QR DECOMPOSITION
        E - GENERAL MATRIX FOR NONLINEAR EQUATIONS
    $CHECK(DECOMP,'E','A\Q\E',2,NO)
  $ELSE
    $HELP
      MATRIX DECOMPOSITION:
        A - RECTANGULAR MATRIX
        Q - QR DECOMPOSITION
    $CHECK(DECOMP,'Q','A\Q',2,NO)
  $ENDIF
  $DEFAULT='R'
  $IF(DECOMP='A')
    $IF(NUMBER<3) $DEFAULT='C'
  $ENDIF
  $IF(DECOMP='Q') $DEFAULT='C'
  $IF($DEF(JACA))
    $IF(JACA='D')
      $IF(NAL>0) $JASA='R'
      $HELP
        STORE OF JACOBIAN MATRIX FOR APPROXIMATED FUNCTIONS
          R - ROWWISE
          C - COLUMNWISE
      $CHECK(JASA,DEFAULT,'R\C',1,NO)
      $JASB='C'
      $POMA='$N,NA'
      $IF(JASA='C')
        $JASB='R'
        $POMA='NA,$N'
      $ENDIF
    $ENDIF
  $ENDIF
  $IF(TYPE='L')
    $IF(DECOMP='Q')
      $NUMBER=1
    $ELSEIF(DECOMP='A')
      $HELP
        METHOD
          1 - EXACT SOLUTION BY COMPLETE QR DECOMPOSITION
          3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
          4 - INEXACT SOLUTION BY LSQR METHOD
      $CHECK(NUMBER,3,'1\3\4',2,NO)
    $ELSEIF(DECOMP='E')
      $HELP
        METHOD
          1 - EXACT SOLUTION BY COMPLETE LU DECOMPOSITION
          3 - INEXACT SOLUTION BY SMOOTHED CGS METHOD
          4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
          5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\3\4\5',2,NO)
    $ENDIF
  $ELSEIF(TYPE='G')
    $IF(DECOMP='Q')
      $HELP
        METHOD
          1 - SINGLE DOG-LEG STRATEGIES
          2 - MULTIPLE DOG-LEG STRATEGY
      $CHECK(NUMBER,1,'1\2',2,NO)
    $ELSEIF(DECOMP='A')
      $HELP
         METHOD
           1 - SPECIAL DOG-LEG STRATEGY
           3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
           4 - INEXACT SOLUTION BY LSQR METHOD
           7 - OPTIMUM LOCALLY CONSTRAINED STEP
      $CHECK(NUMBER,3,'1\3\4\7',2,NO)
    $ELSE
      $HELP
        METHOD
          1 - SPECIAL DOG-LEG STRATEGY
          2 - MULTIPLE DOG-LEG STRATEGY
          3 - INEXACT SOLUTION BY CONJUGATE GRADIENT METHOD
          4 - INEXACT SOLUTION BY RESTARTED GMRES METHOD
          5 - INEXACT SOLUTION BY SMOOTHED BICGSTAB METHOD
      $CHECK(NUMBER,3,'1\2\3\4\5',2,NO)
    $ENDIF
  $ENDIF
  $IF(TYPE='L')
    $DEFAULT=0
    $IF(KDF>0) $DEFAULT=1
    $IF(KDA>0) $DEFAULT=1
    $IF(DEFAULT=1)
      $HELP
        DEGREE OF DIRECTIONAL DERIVATIVES IN LINE SEARCH:
          0 - NO DIRECTIONAL DERIVATIVES
          1 - FIRST DIRECTIONAL DERIVATIVES
      $CHECK(KDS,$DEFAULT,'0\1',4,NO)
    $ELSE
      $KDS=0
    $ENDIF
    $IF(KDS=0)
      $HELP
        LINE SEARCH INTERPOLATION
          1 - BISECTION
          2 - TWO POINT QUADRATIC INTERPOLATION
          3 - THREE POINT QUADRATIC INTERPOLATION
          4 - THREE POINT CUBIC INTERPOLATION
          5 - SPECIAL BIQUADRATIC INTERPOLATION
      $CHECK(MES,4,'1\2\3\4\5',3)
      $IF(MES=5) $STEP=4
    $ENDIF
    $HELP
      CHOICE OF THE INITIAL STEPSIZE:
        /        0 - INITIAL STEPSIZE IS SPECIFIED IN THE CALLING PROGRAM
          -1 OR 1 - UNIT INITIAL STEPSIZE
          -2 OR 2 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (DAVIDON)
          -3 OR 3 - COMBINED UNIT AND QUADRATICALLY ESTIMATED INITIAL
                    STEPSIZE (STOREY )
          -4 OR 4 - QUADRATICALLY ESTIMATED INITIAL STEPSIZE
        INITS < 0 - THE PREVIOUS FUNCTION VALUE IS USED
        INITS > 0 - THE MINIMUM  FUNCTION VALUE IS USED
    $CHECK(INITS,-2,'-4\-3\-2\-1\1\2\3\4',4)
    $HELP
      CONTROLLING OF THE INITIAL STEPSIZE:
        0-NO CONTROLLING OF THE INITIAL STEPSIZE
        1-CONTROLLING BASED ON THE FUNCTION DECREASE
        2-CONTROLLING BASED ON THE DIRECTION VECTOR
        3-CONTROLLING BASED ON THE NUMBER OF FUNCTIONS
    $CHECK(ISTEP,0,'0\1\2\3',4)
    $HELP
      LOWER BOUND FOR STEPSIZE PARAMETER
    $CHECK(ALF1,'1.0$P-15',REAL,4)
  $ELSE
    $ISTEP=0
    $HELP
      DECISION AFTER ZERO STEP
        0 - NEW DIRECTION DETERMINATION
        1 - CONTINUATION OF THE ITERATION
    $CHECK(MOT3,0,'0\1',4)
  $ENDIF
  $INITH=-1
  $HELP
    CHOICE OF THE INITIAL APPROXIMATION OF THE HESSIAN
    MATRIX:
     -1 - STEEPEST DESCENT DIRECTION
      1 - UNIT INITIAL APPROXIMATION
      2 - RANDOM INITIAL APPROXIMATION
      3 - NUMERICAL INITIAL APPROXIMATION
  $CHECK(INITH,-1,'-1\1\2\3',4)
  $IF(DECOMP='E')
    $UPDATE='NO'
  $ELSE
    $HELP
      TYPE OF UPDATE
        L - NEW HYBRID UPDATE
        S - SHENG AND ZHOU UPDATE
        N - NO UPDATE
    $CHECK(UPDATE,'S','L\S\NO\N',3,NO)
  $ENDIF
  $IF(UPDATE='N') $UPDATE='NO'
  $IF(UPDATE='L')
    $MET1=1
    $MET2=1
    $HELP
      RESTART OF VARIABLE METRIC METHODS:
        1 - SIMPLE UPDATE
        2 - CUMMULATIVE UPDATE
    $CHECK(MET5,2,'1\2',4)
    $DEFAULT='5.0D-4'
    $IF(TYPE='L') $DEFAULT='3.0D-2'
    $HELP
      TOLERANCE FOR APPLICATION OF THE VARIABLE METRIC UPDATE
    $CHECK(ETA5,DEFAULT,REAL,4)
  $ELSEIF(UPDATE='S')
    $HELP
      SELECTION OF SELF SCALING:
        1 - STANDARD SELF SCALING
        2 - SELF SCALING BY BIGGS
    $CHECK(MET2,1,'1\2',4)
    $HELP
      SELECTION OF STRUCTURED UPDATES:
        1 - STANDARD STRUCTURED UPDATES
        2 - TOTALLY STRUCTURED UPDATES
    $CHECK(MET3,1,'1\2',4)
    $HELP
      RESTART OF VARIABLE METRIC METHODS:
        1 - BASIC QN CONDITION
        2 - QN CONDITION WITH INTERMEDIATE GRADIENT
    $CHECK(MET4,1,'1\2',4)
    $QCON=MET4
  $ENDIF
  $HELP
    CHOICE OF THE SCALING MATRIX:
      0 - UNIT MATRIX (NO SCALING)
      1 - SQUARE OF THE MATRIX H DIAGONAL
  $CHECK(MOS1,0,'0\1',4)
  $ISNF=0
  $ISNA=3
  $ADD(INIT)
    ISNA=3
  $ENDADD
  NDECF=0
  $SUBST('UO0FU1')
  $SUBST('UZLIND')
  $MAL=NA
   MAL=NA
  $JOB=1
  $IF(NORMA>0) $SUBST('UANRL1')
  $IF(NORMF>0) $SUBST('UATRL1')
  $IF(NCL>0)
    $MCL=NCL
     MCL=NCL
    $ISNC=3
    $ADD(INIT)
      ISNC=3
    $ENDADD
    $JOB=1
    $IF(NORMC>0) $SUBST('UCNRL1')
    $IF(NORMF>0) $SUBST('UCTRL1')
    $SUBST('UCLNF2')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYFP$(CONSTR)1')
*
*     --------------------------------------------
*     GAUSS-NEWTON METHOD WITH THE JACOBIAN MATRIX
*     TEMPLATE : U1SDU1
*     --------------------------------------------
*
  $LMD=$10
  ASSIGN $20 TO IMD
  CALL UYPRO1('UXFU',1)
  CALL UYPRO3(-1)
  MOT=0
  T=ZERO
  FO=FMIN
  IPOM1=0
  METS=MET
$L=$10 ; $LABEL
  $KD=1
  $IF(UPDATE='L')
    $AGS=AG
    $AG=AGO
  $ENDIF
  $SUBST('UZMODL')
  $IF(UPDATE='L')
    $AG=AGS
$REM  $ELSE
$REM    IDECA=0
  $ENDIF
  IF (KD.GT.0) P=UXVDOT(NF,$G,$S)
$REM  $IF(KDS<1)
$REM  $ELSE
$REM    IF (TSS(NS).EQ.'UUXX') P=UXVDOT(NF,$G,$S)
$REM  $ENDIF
  GO TO IMD
$L=$20 ; $LABEL
  $IF(UPDATE='L')
    IF (NIT.EQ.LIT) CALL UXVCOP(NF*NA,$AGO,$AG)
  $ENDIF
  $SUBST('UYTR$(CONSTR)G')
  $SUBST('UO2FU3')
  $SUBST('UYFUT1')
  IF (ITERM.NE.0) GOTO $80
  $IF(CONSTR<>'U') $SUBST('UYRM$(CONSTR)0')
  $IF(ISTEP=2)
    DMAX=R*SNORM
  $ENDIF
$L=$30 ; $LABEL
  ASSIGN $30 TO IMD
  $IF(UPDATE='S')
    $SUBST('UUDRD2')
  $ELSE
    IF (IREST.GT.0) CALL UYSET3
  $ENDIF
  IF (ITERM.NE.0) GOTO $80
  $MAT='G'
  $IF(DECOMP='Q')
    $IF(NUMBER=2) $MAT='D'
    $IF(NUMBER=7) $MAT='D'
  $ENDIF
  $DEC=DECOMP
  $DECOMG=DEC
  $IF(NUMBER=1) $DECOMG='A'
*
*     -----------------------
*     DIRECTION DETERMINATION
*     TEMPLATE : UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)
*     -----------------------
*
  $IF(UPDATE='L')
    $IF(DEC='A')
$REM      IF (IPOM1.EQ.1.OR.IDECA.NE.0) CALL UXVCOP(NF*NA,$AG,$AGO)
      IF (IPOM1.EQ.1) CALL UXVCOP(NF*NA,$AG,$AGO)
      $AGS=AG
      $AG=AGO
    $ELSE
$REM      IF (IPOM1.EQ.1) CALL UXVCOP(NF*NA,$AGO,$AG)
    $ENDIF
  $ENDIF
  $SUBST('UD$(MAT)$(TYPE)$(DECOMG)$(NUMBER)')
  $IF(UPDATE='L')
    $IF(DEC='A')
      $AG=AGS
      IDECA=0
    $ENDIF
  $ENDIF
*
*     ------------------------------
*     END OF DIRECTION DETERMINATION
*     ------------------------------
*
  $SUBST('UD1T$(TYPE)1')
  IF (ITERM.NE.0) GOTO $80
  IF (IREST.NE.0) GOTO $30
  IF(NIT.EQ.LIT+1) KIT=NIT
$L=$40 ; $LABEL
  $IF(ISTEP>0)
    CALL UYSET4(NF,NA,INITS,ISTEP,F,FO,SNORM,DMAX)
  $ENDIF
  $SUBST('UYTR$(CONSTR)S')
  CALL UXVCOP(NA,$AF,$AFO)
$L=$50 ; $LABEL
  ASSIGN $50 TO IMD
  $SUBST('UZLINS')
  GOTO ($54,$52) ISB+1
$L=$ 52 ; $LABEL
  CALL UXVDIR(NF,R,$S,$XO,$X)
  GOTO $10
$L=$ 54 ; $LABEL
  IF (ITERS.LE.0) THEN
  $IF(KDS<1)
    $SUBST('UYZER0')
  $ELSE
    $SUBST('UYZER1')
  $ENDIF
  $IF(TYPE='L')
    CALL UXVCOP(NA,$AFO,$AF)
  $ELSE
    IF (MOT3.LE.0) CALL UXVCOP(NA,$AFO,$AF)
  $ENDIF
  IF(IDIR.EQ.0) THEN
  CALL UYRES1(TSXX)
  CALL UYSET1
  GO TO $30
  ELSE IF (MOT3.EQ.0) THEN
  CALL UYSET1
  GO TO $30
  ELSE
  ITERD=0
  ENDIF
  ENDIF
  IF(KD.GT.LD) THEN
$REM  IF (FO-F.LE.ETA5*FO) THEN
$REM  ISNA=1
$REM  ENDIF
  $IF(UPDATE='L')
    IDECS=IDECA
  $ENDIF
  ASSIGN $70 TO IMD
  GO TO $10
  ENDIF
$L=$70 ; $LABEL
$REM  ISNA=3
  $IF(UPDATE='L')
    IDECA=IDECS
  $ENDIF
  TXFU=TUXX
  TUXX='NEWTON  '
  ITERD=0
  $IF(UPDATE='L')
    $SUBST('UYTRUD')
    IF (MET5.EQ.1) THEN
    CALL UXVCOP(NF*NA,$AGO,$AG)
    IDECA=0
    ENDIF
    POM=MIN(ETA5,ONE-P*P/(TWO*FO*(P-PO)))
    IF (FO-F.LE.POM*FO) THEN
    IPOM1=1
    $SUBST('UUDGA3')
    ELSE
    IPOM1=0
    IF (MET5.EQ.2) THEN
    CALL UXVCOP(NF*NA,$AGO,$AG)
    IDECA=0
    ENDIF
    ENDIF
  $ELSEIF(UPDATE='S')
    $IF(MET2=2)
      PAR=UXVDOT(NA,$AF,$AFO)/UXVDOT(NA,$AFO,$AFO)
    $ENDIF
    $SUBST('UYTR$(CONSTR)D')
    $IF (MET4=2)
      CALL UXVDIF(NF,$G,$GS,$GA)
    $ENDIF
    $AGS=AG
    $SUBST('UUDGA2')
    $AG=AGS
  $ELSE
    $SUBST('UYTRUD')
  $ENDIF
  $IF(CONSTR<>'U') $SUBST('UYAD$(CONSTR)0')
  MET=METS
  IF(IDIR.EQ.0) THEN
  IF(ITERH.NE.0) CALL UYRES1('UPDATE  ')
  GOTO $20
  ELSE
  GOTO $30
  ENDIF
$L=$80 ; $LABEL
  IF(ITERM.LT.0) TXFU=TDXX
  CALL UYEPI1(1)
  $IF(NAL>0)
    $JOB=-1
    $IF(NORMA>0) $SUBST('UANRL1')
  $ENDIF
  $IF(NCL>0)
    $JOB=-1
    $IF(NORMF>0) $SUBST('UCTRL1')
    $IF(NORMC>0) $SUBST('UCNRL1')
  $ENDIF
  $SUBST('UO1FU2')
  $ADD(INIT)
    NXFU='U1SDU1'
  $ENDADD
  $EXIT
