$INTERFACE UDSLE2                                             97/12/01
$REM LU
  $CON1='1.0$P-2'
  $CON2='1.0$P-60'
  $CON3='2.0$P 0'
  $ICON1=0
  $ICON2=4
  $ICON3=32
  $ICON4=5
  $ICON5=8
  $HELP
    TOLERANCE FOR POSITIVE DEFINITENESS
  $CHECK(ETA2,'ETA0*1.0D-3',REAL,4)
  $HELP
    LOWER BOUND FOR GRADIENT
  $CHECK(TOLG,'1.0$P-8',REAL,3)
  CALL UOD1D1
  IF (IDECA.LT.0) THEN
  $N='NF'
  $ADD(REAL,'\ALF\BET\C1\C2\C3')
  $BG='BG'
  $IBG='IBG'
  $JBG='JBG'
  $ADD(REAL,'\$BG($MMAX)\$AG($MA)\$AF($NA)\$AFO($NA)\$AFD($NA)\$GN($NF)&
 \$SN($NF)\$SO($NF)\$XO($NF)\$GO(2*$NF)')
  $ADD(INTEGER,'\$IBG($MMAX+1)\$JB(15)\$IB(5)\$IAG($NA+1)&
 \$JAG($MA)\$JBG($MA)')
$REM  $ADD(INTEGER,'\I')
  $HELP
    PRELIMINARY PERMUTATION OF THE JACOBIAN MATRIX
      0 - NO PERMUTATION
      1 - PERMUTATION TO BLOCK TRIANGULAR FORM
  $CHECK(MOS1,0,'0\1',3)
  $HELP
    PREFERRENCE OF SYMMETRIC PIVOTS
      0 - SYMMETRIC PIVOTS ARE NOT PREFERRED
      1 - SYMMETRIC PIVOTS ARE PREFERRED
  $CHECK(MOS2,0,'0\1',3)
  $POM=2
  IDECA=0
  ENDIF
  IF (LD.LE.ZERO) CALL UXSCMM($N,NA,MA,$AG,$IAG,$JAG,$AF,$GN)
  IF(IDECA.EQ.0) THEN
  CALL UXSGMC($N,MA,$AG,$IAG,$JAG,ETA2)
*
*     LU DECOMPOSITION
*
  IF (NIT-LIT.LE.1) THEN
  DO $20 I=1,NA
  DO $10 KA=$IAG(I),$IAG(I+1)-1
  $JBG(KA)=I
$10 CONTINUE
$20 CONTINUE
  CALL UXIINI($JB,INF,1,MMAX+1,1,MMAX+1)
  CALL UXSGDS($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,IB,INF,$CON1&
,$CON2,$CON3,$ICON1,$ICON2,$ICON3,$ICON4,$MOS1,$MOS2)
  ELSE
  CALL UXSGDF($BG,$IBG,$JB,$AG,$JAG,$JBG,$N,MA,IB,INF,$CON2&
,$ICON3)
  ENDIF
  NDECA=NDECA+1
  IDECA=2
  IF (INF.NE.0) THEN
  ITERD=-7
  TDXX='DEC ERR '
  GOTO $30
  ENDIF
  ELSE IF (IDECA.EQ.2) THEN
  ELSE
  ITERD=-1
  TDXX='BAD DEC$POM'
  CALL UOERR1('UDSLE2',1)
  GOTO $30
  ENDIF
  GNORM=SQRT(UXVDOT($N,$GN,$GN))
  IF (KD.LE.0) THEN
  IF (GNORM.LE.TOLG) THEN
  ITERM=4
  TXFU='GRAD TOL'
  GO TO $30
  ENDIF
  ENDIF
*
*     NEWTON DIRECTION
*
  IF (NIT-LIT.LE.1) THEN
  CALL UXVNEG($N,$AF,$SN)
  CALL UXSGDB($BG,$IBG,$JB,$N,IB,INF,$SN,$SN,$GO,$CON2,$ICON5,0)
  IF(INF.EQ.0) THEN
  ITERD = 1
  TDXX='LU  REG '
  ENDIF
  GO TO $25
  ENDIF
*
*     TENSOR DIRECTION
*
  CALL UXVNEG($N,$AF,$SO)
  CALL UXSGDB($BG,$IBG,$JB,$N,IB,INF,$SO,$SO,$GO,$CON2,$ICON5,0)
  IF(INF.EQ.0) THEN
  ITERD = 1
  TDXX='LU  REG '
  ENDIF
  CALL UXSGDB($BG,$IBG,$JB,$N,IB,INF,$XO,$AFD,$GO,$CON2,$ICON5,1)
  CALL UXSRMD($N,NA,MA,$AG,$IAG,$JAG,$XO,-ONE,$AFO,$AFO)
  CALL UXVSCL(NA,TWO/UXVDOT($N,$XO,$XO)**2,$AFO,$AFO)
  C1=UXVDOT(NA,$AFD,$AFO)
  C2=UXVDOT(NA,$AFD,$AF)
  IF (TWO*C1*C2.LE.ONE) THEN
  BET=TWO*C2/(ONE+SQRT(ONE-TWO*C1*C2))
  CALL UXVDIR(NA,HALF*BET*BET,$AFO,$AF,$AFO)
  ELSE
  BET=-ONE/C1
  C3=C2+BET+HALF*BET*BET*C1
  CALL UXVDIR(NA,HALF*BET*BET,$AFO,$AF,$AFO)
  CALL UXVDIR(NA,-C3/UXVDOT(NA,$AFD,$AFD),$AFD,$AFO,$AFO)
  ENDIF
  CALL UXSGDB($BG,$IBG,$JB,$N,IB,INF,$AFO,$SN,$GO,$CON2,$ICON5,0)
  CALL UXVNEG($N,$SN,$SN)
$25 CONTINUE
  P=UXVDOT($N,$SN,$GN)
  INITD=MAX(ABS(INITD),1)
  ITERD=1
  NRED=INF
  SNORM=SQRT(UXVDOT($N,$SN,$SN))
  $IF(DEC='P')
  GNORM=SNORM
  $ENDIF
  CALL UOD1D5(ALF,ZERO,INF)
$30 CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDSLE2'
  $ENDADD
  $EXIT
