$INTERFACE UDVLV1                                             97/12/01
$REM LU
  $D='D'
  $UO='UO'
  $VO='VO'
  $IF(CONSTR='C')
    $POM1='U'
    $POM2=',$$IX,KBF)'
    $POM3='C'
    $ADD(INTEGER,'\$IX($NF)')
  $ELSE
    $POM1='V'
    $POM2=')'
    $POM3='S'
  $ENDIF
  $HELP
    NUMBER OF BFGS CORRECTIONS
  $CHECK(MF,5,INT,2)
  $HELP
    SELECTION OF THE SELF SCALING
      1 - SELF SCALING SUPRESSED
      2 - SCALAR SELF SCALING
      3 - DIAGONAL SELF SCALING
      4 - SCALAR AND DIAGONAL SELF SCALING
      5 - STEIGAUG NEWTON TYPE SCALING
  $CHECK(MET1,2,'1\2\3\4\5',4)
  $HELP
    TERMINATION CRITERION:
      1-PERFECT LINE SEARCH
      2-GOLDSTEIN STEPSIZE
      3-WEAK WOLFE STEPSIZE
      4-STRONG WOLFE STEPSIZE
      5-ARMIJO STEPSIZE
  $CHECK(KTERS,3,'1\2\3\4\5',4)
  $HELP
    RESTART SPECIFICATION. RESTART IS PERFORMED AFTER
    IRES1*N+IRES2 ITERATIONS.
  $CHECK(IRES1,999,INT,4)
  $HELP
    TERMINATION TOLERANCE FOR LINE SEARCH
    (IN TEST ON THE CHANGE OF THE DIRECTIONAL DERIVATES)
  $CHECK(EPS2,'0.8$P 0',REAL,4)
  $IF(MET1<3) $D='X'
  $ADD(REAL,'\$GN($NF)\$SN($NF)\$XO($NF*$MF)\$GO($NF*$MF)\$UO($MF)&
  \$VO($MF)\$D($NF)')
  $ADD(REAL,'\A\B\C')
  $ADD(REAL,'\UXVDOT')
  $ADD(INTEGER,'\MX')
  $IF(MET1=3)
  $ADD(REAL,'\UXVVDQ')
  $ELSEIF(MET1=4)
  $ADD(REAL,'\UXVVDP\UXVVDQ')
  $ENDIF
$REM  $N='N'
  CALL UOD1D1
  $IF(MET1=5)
    $XOS=XO
    $GAS=GA
    $GA=G
    $ADD(REAL,'\$XS($NF)\$GS($NF)')
    CALL UX$(POM1)COP($N,$X,$XS$POM2
  $ENDIF
  GNORM=SQRT(UX$(POM1)DOT($N,$GN,$GN$POM2)
  INITD=MAX(ABS(INITD),1)
  IF(IREST.NE.0) GO TO $20
  MX=MIN(NIT-KIT,MF)
  IF (MX.LE.0) THEN
  CALL UYRES1('EMPTY   ')
  GO TO $20
  ENDIF
*
*     DETERMINATION OF THE PARAMETER B
*
  B=UX$(POM1)DOT($N,$XO,$GO$POM2
  IF (B.LE.ZERO) THEN
  CALL UYRES1('B   NEG.')
  GO TO $20
  ENDIF
  $UO(1)=ONE/B
  CALL UX$(POM1)NEG($N,$GN,$SN$POM2
  CALL UXDR$(POM3)B($N,MX,$XO,$GO,$UO,$VO,$SN$POM2
  TDXX='UNIT    '
  $IF(MET1=1)
  $ELSEIF(MET1=2)
    A=UX$(POM1)DOT($N,$GO,$GO$POM2
    IF (A.GT.ZERO) THEN
    CALL UXVSCL($N,B/A,$SN,$SN)
    TDXX='SCALAR  '
    ENDIF
  $ELSEIF(MET1=3)
    C=UXVVDQ($N,$D,$XO,$XO)
    IF (C.GT.ZERO) THEN
    CALL UXVDUP($N,$D,B,C,$XO,$GO)
    CALL UXVMUL($N,$D,$SN,$SN,-1)
    TDXX='D-UNIT  '
    ENDIF
  $ELSEIF(MET1=4)
    A=UXVVDP($N,$D,$GO,$GO)
    IF (A.GT.ZERO) THEN
    CALL UXVSCL($N,A/B,$D,$D)
    TDXX='SCALAR  '
    ENDIF
    C=UXVVDQ($N,$D,$XO,$XO)
    IF (C.GT.ZERO) THEN
    CALL UXVDUP($N,$D,B,C,$XO,$GO)
    CALL UXVMUL($N,$D,$SN,$SN,-1)
    IF (TDXX.EQ.'UNIT    ') TDXX='D-UNIT  '
    IF (TDXX.EQ.'SCALAR  ') TDXX='D-SCALAR'
    ENDIF
  $ELSEIF(MET1=5)
    FO=F
    PP=SQRT(ETA0/UX$(POM1)DOT($N,$SN,$SN$POM2)
    LD=MIN(MAX(KDF,KDA)-1,0)
    $IF(MODEL='AF')
      LDA=LD
    $ELSE
      LDA=-1
    $ENDIF
    I=ISNA
    ISNA=0
    $XO=XS
    $SUBST('UYTR$(CONSTR)X')
    ASSIGN $30 TO IMD
    GO TO $LMD
$30 CONTINUE
    ISNA=I
    $XO=XOS
    $SUBST('UYTR$(CONSTR)A')
    CALL UXVDIF($N,$G,$GN,$GS)
    F=FO
    CALL UXVSCL($N,ONE/PP,$GS,$GS)
    CALL UXVSCL($N,UXVDOT($N,$SN,$SN)/UXVDOT($N,$GS,$SN),$SN,$SN)
  $ENDIF
  CALL UXDR$(POM3)F($N,MX,$XO,$GO,$UO,$VO,$SN$POM2
  SNORM=SQRT(UX$(POM1)DOT($N,$SN,$SN$POM2)
  TUXX='BFGS-   '
  WRITE (TUXX(6:7),'(I2)') MX
  MX=MIN(MX+1,MF)
  CALL UXDRSU($N,MX,$XO,$GO,$UO)
$20 CONTINUE
  ITERD=0
  IF(IREST.NE.0) THEN
*
*     STEEPEST DESCENT DIRECTION
*
  $IF(MET1>2)
    CALL UXVSET($N,ONE,$D)
  $ENDIF
  CALL UX$(POM1)NEG($N,$GN,$SN$POM2
  SNORM=GNORM
  TUXX='INITIAL '
  TDXX='ST.DESC.'
  CALL UYSET3
  ENDIF
  $IF(MET1=5)
    CALL UXVCOP(NF,$XS,$X)
    CALL UXVCOP(NF,$GN,$G)
    $GA=GAS
  $ENDIF
  CALL UOD1D2($N,$GN,$SN)
  $ADD(INIT)
    NDXX='UDVLV1'
  $ENDADD
  $EXIT
