$INTERFACE UUDMI1                                             98/12/01
$REM LU
  $CON0='0.1$P 0'
  $CON1='1.05$P 0'
  $CON2='1.0$P 1'
  $CON3='0.2$P 0'
  $CON4='1.0$P-2'
  $CON5='3.0$P-8'
  $CON6='1.0$P-4'
$REM  $IF($DEF(MOS5))
$REM  $ELSE
$REM    $MOS5=0
$REM  $ENDIF
  $HELP
    METHOD OF UPDATE OF HESSIAN MATRIX:
      1 - BFGS UPDATE
      2 - DFP UPDATE
      3 - HOSHINO UPDATE
      4 - SAFEGUARDED RANK ONE UPDATE
      5 - OPTIMALLY CONDITIONED UPDATE
      6 - SIMPLE PRECONVEX UPDATE
      7 - VARIATIONALLY DERIVED PRECONVEX UPDATE
      8 - NEW COMBINED UPDATE
  $CHECK(MET,8,'1\2\3\4\5\6\7\8',3)
  $IF(MET=2)
    $MET1=5
  $ELSE
    $HELP
      SELECTION OF SELF SCALING:
        ABS(MET1)=1 - SELF SCALING SUPPRESSED
        ABS(MET1)=2 - INITIAL SELF SCALING
        ABS(MET1)=3 - CONTROLLED SELF SCALING
        ABS(MET1)=4 - SIMPLIFIED CONTROLLED SELF SCALING
        ABS(MET1)=5 - SELF SCALING IN EACH ITERATION
             MET1>0 - BASIC INITIAL SELF SCALING
             MET1<0 - MODIFIED INITIAL SELF SCALING
    $CHECK(MET1,3,'-5\-4\-3\-2\-1\1\2\3\4\5',4)
  $ENDIF
  $NET1=MET1
  $IF(NET1=-1) $NET1=1
  $IF(NET1=-2) $NET1=2
  $IF(NET1=-3) $NET1=3
  $IF(NET1=-4) $NET1=4
  $IF(NET1=-5) $NET1=5
  $HELP
    SELECTION OF AN INTERPOLATION MODEL:
      0 - SINGLE-STEP (CLASSIC) VARIABLE METRIC METHODS
      1 - DOUBLE STEP EQUIDISTANT MODEL
      2 - DOUBLE STEP ACCUMULATIVE MODEL
      3 - DOUBLE-STEP FIXED-POINT MODEL
      4 - DOUBLE-STEP FIXED-POINT MODEL
  $CHECK(MET2,4,'0\1\2\3\4',4)
  $N='N'
  $ADD(REAL,'\$H($NF*($NF+1)/2)\$GN($NF)\$S($NF)\$XO($NF)\$GO($NF)')
  $POM4='($N,$H,$S,$XO,$GO,R,PO'
  $POM6='(N,H,S,XO,GO,R,PO'
  $ADD(POM4,',$XS,$GS,$XP,$GP')
  $ADD(POM6,',XS,GS,XP,GP')
  $ADD(REAL,'\$XS($NF)\$GS($NF)\$XP($NF)\$GP($NF)')
  $IF(NET1=3)
    $ADD(POM4,',PAR1,PAR2')
    $ADD(POM6,',PAR1,PAR2')
  $ENDIF
$REM  $IF(MOS5=0)
  $ADD(POM4,',ETA9,MET)')
  $ADD(POM6,',ETA9,MET)')
$REM  $ELSE
$REM    $ADD(REAL,'\GAM\RHO\AUPD\BUPD\CUPD\ETA')
$REM    $ADD(POM4,',ETA9,MET,GAM,RHO,AUPD,BUPD,CUPD,ETA)')
$REM    $ADD(POM6,',ETA9,MET,GAM,RHO,A,B,C,ETA)')
$REM  $ENDIF
  $NUMSUB=''
  $IF(NMET>1) $NUMSUB='_$NMET'
  CALL UUDMI1$(NUMSUB)$POM4
  $ADD(SUBROUTINES)
*     ----------------------------------------
*     BROYDEN CLASS OF VARIABLE METRIC UPDATES
*     TEMPLATE : UUDMI1
*     ----------------------------------------
  SUBROUTINE UUDMI1$(NUMSUB)$POM6
  $$INCLUDE('UMCOMM')
  INTEGER N,MET
  $$FLOAT H(N*(N+1)/2),S(N),XO(N),GO(N),R,PO,ETA9
  $$FLOAT XS(N),GS(N),XP(N),GP(N)
  $$IF($NET1=3) $$FLOAT PAR1,PAR2
  $$FLOAT AA,CC
  $$FLOAT UXVDOT,UNFUN1
  $$FLOAT DIS,POM,POM1,POM2,POM3,POM4,A,B,C,GAM,RHO,PAR,ETA
  $$IF($MET>2) $$FLOAT DEN
  INTEGER IUPDT
  LOGICAL L1,L3,L4
  $$IF ($NET1=3) LOGICAL L2
  EXTERNAL UNFUN1
  IF (MET.LE.0) GO TO 22
  CALL UOU1D1(N,XO,GO)
  IF (IDECF.NE.9) THEN
  ITERH=-1
  TUXX='BAD DEC9'
  CALL UOERR1('UUDMI1',1)
  GO TO 22
  ENDIF
  L1=ABS($MET1).GE.3.OR.ABS($MET1).EQ.2.AND.NIT.EQ.KIT
  L3=.NOT.L1
  L4=NIT.GT.KIT.AND.$MET2.GT.0
*
*     DETERMINATION OF INTERPOLATION POINTS
*
  IF (L4) THEN
  $$IF($MET2=2)
    POM1=-SQRT(ABS(UXVDOT(N,XS,GS)))
    POM2=ZERO
    POM3= SQRT(-R*PO)
  $$ELSEIF($MET2=3)
    POM1=-SQRT(ABS(UXVDOT(N,XS,GS)+TWO*UXVDOT(N,XO,GS)-R*R*PO))
    POM2=-SQRT(-R*R*PO)
    POM3=ZERO
  $$ELSEIF($MET2=4)
    POM1=ZERO
    POM2=SQRT(ABS(UXVDOT(N,XS,GS)))
    POM3=SQRT(ABS(UXVDOT(N,XS,GS)+TWO*UXVDOT(N,XO,GS)-R*R*PO))
  $$ENDIF
  $$IF($MET2>0)
    $$IF($MET2=1)
      POM4=ONE
    $$ELSE
      POM4=(POM3-POM2)/(POM2-POM1)
    $$ENDIF
$REM    CALL UXVLIN(N,TWO*POM4+ONE,XO,-POM4**2,XS,XP)
$REM    CALL UXVLIN(N,TWO*POM4+ONE,GO,-POM4**2,GS,GP)
    POM=POM4*POM4/(TWO*POM4+ONE)
    CALL UXVDIR(N,-POM,XS,XO,XP)
    CALL UXVDIR(N,-POM,GS,GO,GP)
  $$ELSE
    CALL UXVCOP(N,XO,XP)
    CALL UXVCOP(N,GO,GP)
  $$ENDIF
  ELSE
  CALL UXVCOP(N,XO,XP)
  CALL UXVCOP(N,GO,GP)
  ENDIF
*
*     DETERMINATION OF PARAMETERS A, B, C
*
11 CONTINUE
  B=UXVDOT(N,XP,GP)
  IF (B.LE.ZERO) THEN
  IF (L4) THEN
  CALL UXVCOP(N,XO,XP)
  CALL UXVCOP(N,GO,GP)
  L4=.FALSE.
  GO TO 11
  ELSE
  ITERH=2
  TUXX='B - NEG.'
  GO TO 22
  ENDIF
  ENDIF
  CALL UXDSMM(N,H,GP,S)
  A=UXVDOT(N,GP,S)
  IF (A.LE.ZERO) THEN
  ITERH=1
  TUXX='A - NEG.'
  GO TO 22
  ENDIF
  IF(MET.GE.4.OR.L1) THEN
  IF (ITERD.NE.1) THEN
  MET=1
  C=ZERO
  ELSE
  C=-R*PO
  IF (C.LE.ZERO) THEN
  ITERH=3
  TUXX='C - NEG.'
  GO TO 22
  ENDIF
  ENDIF
  ELSE
  C=ZERO
  ENDIF
  RHO=ONE
  AA=A/B
  CC=C/B
  IUPDT=0
  IF (L1) THEN
*
*     DETERMINATION OF THE PARAMETER GAM (SELF SCALING)
*
  IF (C.LE.ZERO) THEN
  PAR=A/B
  POM3=0.8$P 0
  POM4=8.0$P 0
  ELSE
  $$IF($MET=1)  $$IUPDT=3
  $$IF($MET=2)  $$IUPDT=2
  $$IF($MET=3)  $$IUPDT=3
  $$IF($MET=4)  $$IUPDT=3
  $$IF($MET=5)  $$IUPDT=3
  $$IF($MET=6)  $$IUPDT=3
  $$IF($MET=7)  $$IUPDT=1
  $$IF($MET=8)  $$IUPDT=3
  $$IF(IUPDT=1)
    PAR=A/B
    POM3=0.8$P 0
    POM4=8.0$P 0
  $$ELSEIF(IUPDT=2)
    PAR=B/C
    POM3=0.6$P 0
    POM4=4.0$P 0
  $$ELSEIF(IUPDT=3)
    PAR=SQRT(A/C)
    POM3=0.7$P 0
    POM4=6.0$P 0
  $$ENDIF
  ENDIF
  GAM=RHO/PAR
  $$IF($MET1<0)
    IF (NIT.EQ.KIT) THEN
    GAM=MAX(GAM,$CON6)
    GAM=MIN(GAM,ONE/$CON6)
    PAR=RHO/GAM
    ENDIF
  $$ENDIF
  $$IF($NET1=3)
    IF (NIT.NE.KIT) THEN
    L2=PAR2.LE.ZERO
    L3=L2.AND.ABS(PAR1).LE.$CON3
    L3=L3.OR.(.NOT.L2.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.LT.ZERO.AND.GAM.GT.ONE)
    L3=L3.OR.(L2.AND.PAR1.GT.ZERO.AND.GAM.LT.ONE)
    L3=L3.OR.GAM.LT.POM3
    L3=L3.OR.GAM.GT.POM4
    ENDIF
  $$ELSEIF($NET1=4)
    IF (NIT.NE.KIT) THEN
    L3=GAM.LT.POM3.OR.GAM.GT.POM4
    ENDIF
  $$ENDIF
  ENDIF
  IF (L3) THEN
  GAM=ONE
  PAR=RHO/GAM
  ENDIF
  $$U17=0
  $$U18=0
  $$U19=0
  $$U20=0
  $$IF($MET=1)
    $$U17=1
    NUPD=NUPD+1
  $$ELSEIF($MET=2)
*
*     DFP UPDATE
*
    ETA=ZERO
    CALL UXDSMU(N,H,PAR/B,XP)
    CALL UXDSMU(N,H,-ONE/A,S)
    TUXX='DFP     '
  $$ELSEIF($MET=3)
*
*     HOSHINO UPDATE
*
    DEN=PAR*B+A
    DIS=HALF*B
    ETA=PAR*B/DEN
    CALL UXVDIR(N,PAR,XP,S,S)
    CALL UXDSMU(N,H,PAR/DIS,XP)
    CALL UXDSMU(N,H,-ONE/DEN,S)
    TUXX='HOSHINO '
    NUPD=NUPD+1
  $$ELSEIF($MET=4)
*
*     SAFEGUARDED RANK ONE UPDATE
*
    $$U17=1
    $$U18=1
    DEN=PAR*B-A
    DIS=PAR*C-B
    IF (DEN.GT.ZERO) GO TO 18
  $$ELSEIF($MET=5)
*
*     OPTIMALLY CONDITIONED UPDATE
*
    $$U17=1
    $$U18=1
    $$U19=1
    DEN=PAR*B-A
    DIS=PAR*C-B
    IF (PAR*C*DEN.LE.A*DIS) GO TO 19
    IF (DEN.NE.ZERO) GO TO 18
  $$ELSEIF($MET=6)
*
*     SIMPLE PRECONVEX UPDATE
*
    $$U20=1
    ETA=ONE+ONE/SQRT(MAX($ETA0,ONE-ONE/(AA*CC)))
    TUXX='LUKSAN 1'
    NUPD=NUPD+1
  $$ELSEIF($MET=7)
*
*     VARIATIONALLY DERIVED PRECONVEX UPDATE
*
    ETA=TWO
    DIS=TWO*AA
    CALL UXVDIR(N,-DIS,XP,S,S)
    CALL UXDSMU(N,H,ONE/A,S)
    CALL UXDSMU(N,H,(PAR-DIS)/B,XP)
    TUXX='LUKSAN 2'
    NUPD=NUPD+1
  $$ELSEIF($MET=8)
*
*     NEW UPDATE
*
    $$U20=1
    ETA=ONE/(AA*CC)
    DEN=MAX(ETA+$ETA0,(C/A)**0.2$P 0)
    ETA=(DEN-ETA)/MAX($ETA0,ONE-ETA)
    TUXX='NEW     '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U17>0)
17 CONTINUE
*
*     BFGS UPDATE
*
    ETA=ONE
    DIS=PAR+AA
    CALL UXVDIR(N,-DIS,XP,S,XP)
    DIS=ONE/(B*DIS)
    CALL UXDSMU(N,H,DIS,XP)
    CALL UXDSMU(N,H,-DIS,S)
    TUXX='BFGS    '
    GO TO 21
  $$ENDIF
  $$IF(U18>0)
18 CONTINUE
*
*     RANK ONE UPDATE
*
    ETA=PAR*B/DEN
    CALL UXVDIR(N,-PAR,XP,S,XP)
    CALL UXDSMU(N,H,ONE/DEN,XP)
    TUXX='RANK ONE'
    NUPD=NUPD+1
    GO TO 21
  $$ENDIF
  $$IF(U19>0)
19 CONTINUE
*
*     DAVIDON'S UPDATE
*
    DEN=AA*CC-ONE
    IF (DEN.LE.ZERO) GO TO 17
    ETA=(PAR*CC-ONE)/DEN
    TUXX='DAVIDON '
    NUPD=NUPD+1
  $$ENDIF
  $$IF(U20>0)
20 CONTINUE
*
*     GENERAL UPDATE
*
    DEN=PAR+ETA*AA
    DIS=ETA/DEN
    CALL UXDSMU(N,H,(PAR*DIS-ONE)/A,S)
    CALL UXVDIR(N,-DIS,S,XP,S)
    CALL UXDSMU(N,H,DEN/B,S)
  $$ENDIF
21 CONTINUE
  ITERH=0
  IF (GAM.EQ.ONE) GO TO 22
*
*     SCALING
*
  CALL UXDSMS(N,H,GAM)
  NSCL=NSCL+1
22 CONTINUE
  CALL UOU1D2(N,H,S,RHO,GAM,PAR,A,B,C,ETA,ETA9)
  CALL UXVCOP(N,XO,XS)
  CALL UXVCOP(N,GO,GS)
  RETURN
  END
  $ENDADD
  $ADD(INIT)
    NUXX='UUDMI1'
  $ENDADD
  $EXIT
